package su.a71.new_soviet.config;

import net.minecraft.util.Util;
import su.a71.new_soviet.NewSoviet;

import java.io.*;

public class Config {
    private boolean announce_dice = false;

    public static Config INSTANCE;

    public Config() {
        INSTANCE = this;
    }

    // Getters for settings ===========
    public boolean shouldAnnounceDice() {
        return announce_dice;
    }

    // ================================


    private static void generateDefault() {
        INSTANCE = new Config();

        NewSoviet.LOG.info("Generated config file at config/" + NewSoviet.MOD_ID + ".json");
        File file = new File("config/" + NewSoviet.MOD_ID + ".json");
        if(!file.getParentFile().exists() && !file.getParentFile().mkdirs()) {
            NewSoviet.LOG.error("Error making dir, using default config");
            INSTANCE = new Config();
            return;
        }
        try {
            FileWriter writer = new FileWriter(file);
            writer.write(NewSoviet.GSON.toJson(INSTANCE));
            writer.close();
        } catch (Exception e) {
            NewSoviet.LOG.error("Error creating config, using default", e);
        }
    }

    public static void load() {
        // Generate config if it doesn't exist
        File file = new File("config/" + NewSoviet.MOD_ID + ".json");
        if(!file.exists()) {
            generateDefault();
        }

        try {
            BufferedReader reader = new BufferedReader(new FileReader(file));
            StringBuilder sb = new StringBuilder();
            String s;
            while((s = reader.readLine()) != null)
                sb.append(s);
            reader.close();

            INSTANCE = NewSoviet.GSON.fromJson(sb.toString(), Config.class);
        } catch(Exception e) {
            NewSoviet.LOG.error("Error loading config, using default", e);
            INSTANCE = new Config();
        }
    }

    public static void openConfigFile() {
        String configPath = "config/" + NewSoviet.MOD_ID + ".json";
        Util.getOperatingSystem().open(new File(configPath));
    }
}
